/* -*- mode: C++; c-basic-offset: 4; indent-tabs-mode: nil -*- */
// vim: ft=cpp:expandtab:ts=8:sw=4:softtabstop=4:
#ident "Copyright (c) 2012-2013 Tokutek Inc.  All rights reserved."
#ident "$Id: ae4fe94ce655c53b0edb3f1b44b4e7a85ee82ffd $"

#include <pthread.h>
#include <stdio.h>
#include "manager.h"

#define NO_DEPRECATE_PTHREAD_MUTEXES
#include "mutex.h"
#include "check.h"

void pmutex_lock(pthread_mutex_t *mutex, const backtrace bt) throw() {
    int r = pthread_mutex_lock(mutex);
    if (r != 0) {
        printf("HotBackup::pmutex_lock() failed, r = %d", r);
    }
    check_bt(r==0, bt);
}

void pmutex_unlock(pthread_mutex_t *mutex, const backtrace bt) throw() {
    int r = pthread_mutex_unlock(mutex);
    if (r != 0) {
        printf("HotBackup::pmutex_unlock() failed, r = %d", r);
    }
    check_bt(r==0, bt);
}

void pmutex_lock(pthread_mutex_t *mutex) throw() {
    pmutex_lock(mutex, BACKTRACE(NULL));
}

void pmutex_unlock(pthread_mutex_t *mutex) throw() {
    pmutex_unlock(mutex, BACKTRACE(NULL));
}
